#include <stdio.h>
#include <avs/flow.h>
#include <avs/avs_data.h>
#include <avs/field.h>

AVSinit_modules()
{
	int image_to_tga();

	AVSmodule_from_desc(image_to_tga);
}

image_to_tga()
{
	int compute();
	int parm;

	AVSset_module_name("Image to PPM", MODULE_RENDER);

	AVScreate_input_port("Input Image", "field 2D 4-vector byte", REQUIRED);

	parm = AVSadd_parameter("PPM file", "string", NULL, NULL, ".ppm");
   	AVSconnect_widget(parm, "browser");

	AVSset_compute_proc(compute);
}

compute(image, outfile)
AVSfield_char *image;
char *outfile;
{
	int i, j, width, height;
	unsigned char *line, *ptr;
	FILE *fpout;

	if(!outfile)
		return 1;

	if((fpout=fopen(outfile, "w")) == (FILE *)0) {
		AVSerror("Cannot open file for writing", AVS_Warning, "Image to PPM", 
		"read_image_compute", "Ok", "Can't open output file %s", outfile);
		return 1;
	}

	width = image->dimensions[0];
	height = image->dimensions[1];

	fprintf(fpout, "P6\n%d %d 255\n", width, height);

	for(i=0; i<height; i++){
		line = image->data + 4*i*width;
		for(j=0; j<width; j++){
			ptr = line+4*j+1;
			putc(*ptr++, fpout);
			putc(*ptr++, fpout);
			putc(*ptr++, fpout);
		}
    }
	fclose(fpout);

	AVSmodify_parameter("PPM file", AVS_VALUE, NULL, NULL, NULL);
	return 1;
}
